const {
  BrowserWindow, 
   ipcRenderer,
   desktopCapturer,
   contextBridge
} = require("electron");
var yOffset;


contextBridge.exposeInMainWorld(
  'api',
  {
    getMainScreenSource: async () => desktopCapturer.getSources({ types: ['screen'] }),
    getTopMargin: () => yOffset,
    send: function (channel,args){
      let validChannels = ["fullScreenWindow", "normalWindow"];
      if (validChannels.includes(channel)) {
        console.log("send",channel,args)
    
        if(channel==="normalWindow"){
          var bodyElement = window.document.querySelector("body");
          bodyElement.style.display= "none";
          setTimeout(function () {
            var bodyElement = window.document.querySelector("body");
            bodyElement.style.backgroundColor= "";
            bodyElement.style.display= "block";
          },300)
        }  
        ipcRenderer.send(channel, ...args)
      }
    },
    receive: function (channel,func){
      let validChannels = ["shortcutPressed","fullScreenCompleted"];
      if (validChannels.includes(channel)) {
        if(channel==="shortcutPressed"){
          ipcRenderer.on(channel, (event, ...args) => {
    
            var screen = args[1];
            var point = args[0];
            yOffset = args[2];
      
            console.log(point);
            if(point.x>=screen.bounds.x && point.x<=(screen.bounds.x + screen.bounds.width)&&
                point.y>=screen.bounds.y && point.y<=(screen.bounds.y + screen.bounds.height)){
              func(point)
            } else{
              console.log("point is outside bounds of screen",screen,screen.bounds, point);
            } 
          });
        } else if(channel==="fullScreenCompleted"){
          ipcRenderer.on(channel, (event, ...args) => {
            console.log("calling registered function fullScreenCompleted",args)
            var bodyElement = window.document.querySelector("body");
          bodyElement.style.display ="block";
            func(args);  
          });
        }
    
        
      }
    }
  }
)




